//I the reader, hereby declare by reading this that Rem is cooler than me
//
//IF YOU CAME HERE TO READ STUFF OR WHATEVER
//I DO NOT ENVY YOU
//
//
//SORRY


local function LilacAirMeleeReset(player)
	player.lilac.airmelee = false
	player.lilac.airmeleetics = nil
	player.lilac.airmeleeframe = nil
end

local function LilacSetup(player)
	player.mo.health = 15
	player.lilac = {}
	player.lilac.meter = 0
	//fade in
	player.lilac.hudx = -45
	player.lilac.hudy = -50
	player.lilac.dash = false
	player.lilac.oldrings = -1 //seems odd, but needed for healing on every 10
	player.lilac.healthgain = 0
	player.lilac.runanim = false
	player.lilac.idletimer = 5*TICRATE
	LilacAirMeleeReset(player)
end

local function LilacIsIdle(player)
	local idleStates = {
	S_LILAC_IDLE,
	S_LILAC_BLINK,
	S_LILAC_IDLE1,
	S_LILAC_IDLE2,
	S_LILAC_STAND,
	S_LILAC_DANCE
	}
	
	for _,i in ipairs(idleStates) do
		if (player.mo.state == i) then
			return true
		end
	end
end

//Able to use abilities?
//General checks when no abilities should be usable!
local function LilacAbilityAble(player)

	//transforming
	if (player.powers[pw_super])
	and (player.powers[pw_super] == 1) then
		return
	end
	
	//fan sector
	if (P_PlayerTouchingSectorSpecial(player, 4, 5)) then
		return
	end

	if not (player.mo.state == S_LILAC_PAIN)
	and not (player.powers[pw_carry])
	and not (player.lilac.airmelee) 
	and not (player.lilac.dash)
	and not (player.pflags & PF_STASIS)
	and not (player.pflags & PF_JUMPSTASIS)
	and not (player.mo.state == S_PLAY_GASP)
	and not (player.mo.state == S_LILAC_ATTACK)
	and not (player.mo.state == S_LILAC_ATTACK_MOVE) 
	and not (player.mo.state == S_LILAC_STARTSPIN)
	and not (player.mo.state == S_LILAC_SPIN)
	and not (player.mo.state == S_LILAC_BOOST)
	and not (player.mo.state == S_LILAC_VICTORY)
	and not (player.mo.state == S_LILAC_VICTORYEND)
	and not (player.mo.state == S_PLAY_STUN) then
		return true
	end
end

//remove the super flag when using abilities
//restore it when not
local function LilacAntiSuper(player)

	if (player.powers[pw_super]) then return end
	
	if (player.mo.state == S_LILAC_STARTSPIN)
	or (player.mo.state == S_LILAC_SPIN)
	or (player.mo.state == S_LILAC_BOOST)
	or (player.mo.state == S_LILAC_CYCLONE) then
		player.charflags = $1 & ~SF_SUPER
	else
		player.charflags = $1|SF_SUPER
	end
end


//edit sliding so we don't flash
local function LilacAntislide(player)
	if (player.pflags & PF_SLIDING)
	or (player.mo.state == S_PLAY_PAIN) then
		player.mo.frame = B
	end
end

local function LilacRemoveHoming(mo)
	if (mo.target)
	and (mo.target.target)
	and (mo.target.target.skin == "lilac") then
		P_RemoveMobj(mo)
	end
end

addHook("MobjThinker", LilacRemoveHoming, MT_LOCKON)


//disable shield abilities
local function LilacShields(player)
	if (player.mo.skin == "lilac") then
		return true
	end
end

addHook("ShieldSpecial", LilacShields)


local function LilacHeal(player, heal, silent)

	//don't play the sound, it'd get annoying
	if (player.mo.health >= 15) then return end

	if not (silent) then
		S_StartSound(nil, sfx_fpheal, player)
	end
	
	if ((player.mo.health + heal) > 15) then
		player.mo.health = 15
		return
	end

	player.mo.health = $1+heal
	
end

local function LilacHealCheck(player)

	//amount needed to restore 1hp
	local healRings = 10
	if (player.lilac.oldrings)
	and (player.lilac.oldrings < player.rings) then
		player.lilac.healthgain = $1 + (player.rings-player.lilac.oldrings)
		
		if (player.lilac.healthgain >= healRings) then
			local heal = 0
			
			while (player.lilac.healthgain >= healRings) do
				player.lilac.healthgain = $1-healRings
				heal = $1+1
			end
			
			LilacHeal(player, heal)
		end
	end

	player.lilac.oldrings = player.rings

end

//Drain the bar whilst accounting for going under
local function LilacMeterDrain(player, amount)

	if (player.lilac.meter <= 0) then return end

	player.lilac.meter = $1-amount
	
	if (player.lilac.meter < 0) then
		player.lilac.meter = 0
	end
	
end


//reset Lilac stuff on respawn
local function LilacRespawnCheck(player)
	if (player.lilac) then
		LilacHeal(player, 50, true)
		player.lilac.oldrings = -1
		player.lilac.healthgain = 0
		player.lilac.airbonus = false
		LilacAirMeleeReset(player)
	else
		LilacSetup(player)
		player.lilac.meter = -1
	end
end
addHook("PlayerSpawn", LilacRespawnCheck)


local function LilacSpawnMelee(player)
	local hit = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_LILAC_MELEE)
	if (player.mo.eflags & MFE_VERTICALFLIP) then
		hit.eflags = MFE_VERTICALFLIP
	end
	hit.target = player.mo
	hit.scale = player.mo.scale
	hit.fuse = 1
end

local function LilacMeleeObjThink(mo)
	if not (mo.target) 
	or not (mo.target.valid) then
		P_RemoveMobj(mo)
		return
	end
	
	if (mo.target.eflags & MFE_VERTICALFLIP) then
		mo.eflags = MFE_VERTICALFLIP
	end
	
	mo.scale = mo.target.scale
	P_TeleportMove(mo, mo.target.x, mo.target.y, mo.target.z)
end

addHook("MobjThinker", LilacMeleeObjThink, MT_LILAC_MELEE)

//Underwater Stuff

local function LilacBubbleRemover(mo)
	if (mo.target)
	and (mo.target.skin == "lilac") then
		if (mo.target.player)
		and (mo.target.player.powers[pw_spacetime]) then
			return
		end
		P_RemoveMobj(mo)
	end
end

addHook("MobjThinker", LilacBubbleRemover, MT_DROWNNUMBERS)


local function LilacDrowning(player)
	if (S_OriginPlaying(player.mo, sfx_dwnind)) then
		S_StopSoundByID(player.mo, sfx_dwnind)
	end
	
	if (player.lilac.hudx < 0) then
		player.lilac.hudx = $1+3
	end
	
	//prevent exploiting character switching for infinite air
	local extraAir = 0
	if not (player.lilac.airbonus) then
		player.lilac.airbonus = true
		extraAir = ((underwatertics/5)*2)
	end
	
	//
	//SHITTY TIMER HAX
	//
	
	if (player.powers[pw_underwater] <= underwatertics+1) then
		player.powers[pw_underwater] = $1+underwatertics+extraAir
	end
	
	//drown
	if (player.powers[pw_underwater] == underwatertics+2) then
		P_KillMobj(player.mo)
		return
	end


	local drownTime = player.powers[pw_underwater] - underwatertics//-1
	local height = player.mo.z + player.mo.height + FixedMul(8*FRACUNIT, FixedMul(player.mo.scale, player.shieldscale))
	
	local DROWNSTART = 11
	
	if (drownTime/TICRATE <= 8) then
		//let's make our own fake drown bubbles
		//since apparently they're "too good" for us
		//hmpf!
		local deathClock = P_SpawnMobj(player.mo.x, player.mo.y, height, MT_GFZFLOWER1)
		deathClock.scale = player.mo.scale
		deathClock.state = S_INVISIBLE
		deathClock.fuse = 2
		deathClock.flags = mobjinfo[MT_DROWNNUMBERS].flags
		deathClock.sprite = SPR_LTIM
		deathClock.frame = K
		deathClock.target = player.mo
		
		local musicVol = 15*(11-drownTime/TICRATE)
		
		if (musicVol > 100) then
			musicVol = 100
		end
		
		S_FadeMusic(100- musicVol, 2*TICRATE, player)
		//hang on the skull for the last 2 seconds
		if (drownTime > TICRATE*2) then
			deathClock.frame = 12-drownTime/TICRATE
			if ((drownTime/TICRATE) % 2)
				if not (S_SoundPlaying(player.mo, sfx_fptick))
					S_StopSound(player.mo)
					S_StartSound(player.mo, sfx_fptick)
				end
			else
				if not (S_SoundPlaying(player.mo, sfx_fptock))
					S_StopSound(player.mo)
					S_StartSound(player.mo, sfx_fptock)
				end
			end
		end
	end
end

local function LilacBubble(bub, pmo)
	if not (pmo.player) then return end

	if (pmo.skin == "lilac") then
		pmo.player.powers[pw_underwater] = ((underwatertics/5)*2)+underwatertics*2 + 1
		P_RestoreMusic(pmo.player)
		S_FadeMusic(100, 0, player)
	end
end
addHook("TouchSpecial", LilacBubble, MT_EXTRALARGEBUBBLE)


//Bustable walls check

local function LilacLineCollide(mo, line)

	if not (mo.skin == "lilac")
	or not (mo.state == S_LILAC_CYCLONE)
	and not (mo.state == S_LILAC_BOOST) then
		return
	end
	
	
	local sect = {line.frontsector, line.backsector}
	local doStop

	for i = 1,table.maxn(sect),1
		for rover in sect[i].ffloors()
		
			if not (rover.flags & FF_EXISTS)
			or not (rover.flags & FF_BUSTUP) then
				continue
			end
			
			if (P_MobjFlip(mo)*(mo.z+mo.height) > (rover.bottomheight))
			and (P_MobjFlip(mo)*(mo.z+mo.momz) < (rover.topheight))
				EV_CrumbleChain(sect[i], rover)
				doStop = false
			end
		end
	end

	return doStop
end

addHook("MobjLineCollide", LilacLineCollide, MT_PLAYER)



//Abilities

local function LilacAbilities(player)

	//put attack spawning here I guess
	if (player.mo.state == S_LILAC_ATTACK_MOVE)
	or (player.mo.state == S_LILAC_ATTACK) then
		LilacSpawnMelee(player)
	end

	//Cyclone
	//Basically a frankenstein of air drill and slowfall
	//flyangle is our timer
	if (player.flyangle)
	and (player.pflags & PF_THOKKED) then
	
		if (player.lilac.meter == 0) then
			player.mo.state = S_LILAC_JUMPTOFALL
		end
	
		LilacSpawnMelee(player)
	
		//cancel the twirl if your animation is interupted
		if not (player.mo.state == S_LILAC_CYCLONE) then
			player.flyangle = 0
			return
		end
		
		if not (leveltime % 3) then
			LilacMeterDrain(player, 1)
		end
		
		player.flyangle = $1-1
		
		//getmobjgravity to account for nonstandard scales
		local potentialMomz = abs(P_GetMobjGravity(player.mo))
		potentialMomz = -$1*4
		
		if (P_MobjFlip(player.mo)*player.mo.momz < P_MobjFlip(player.mo)*potentialMomz)
			player.mo.momz = P_MobjFlip(player.mo)*potentialMomz
		end
		return
	end

	if (player.lilac.meter < 100) then
		if (leveltime % 2)
		and not (player.lilac.dash) then
			player.lilac.meter = $1+1
		end
	end
end


local function LilacAbilityHit(player)
	
	if not (player.mo.skin == "lilac")
	or (player.lilac.dash)
	or not (LilacAbilityAble(player)) then return end
	
	//Cyclone!
	if not (player.pflags & PF_THOKKED) then
		if (player.lilac.meter >= 10) then
			LilacAirMeleeReset(player)

			local relative = false
			local superMult = 1
			
			//double values if we're super
			if (player.powers[pw_super]) then
				superMult = 2
			end
			
			LilacMeterDrain(player, 10)

			player.mo.state = S_LILAC_CYCLONE
			player.flyangle = (2*superMult)*TICRATE
			player.pflags = $1|PF_THOKKED|PF_SPINNING & ~PF_NOJUMPDAMAGE
			if (P_MobjFlip(player.mo)*player.mo.momz > 0) then
				relative = true
			end
			
			
			P_SetObjectMomZ(player.mo, ((12*superMult)*FRACUNIT), relative)
			
			//slow down!!
			//if (player.speed > player.runspeed) then
				//P_InstaThrust(player.mo, player.mo.angle, ((FixedMul(player.runspeed, player.mo.scale))*2)/3)
			//end
			S_StartSound(player.mo, sfx_fpcycl)
			
			//voiceline
			if not (leveltime % 3) then
				S_StartSound(player.mo, sfx_lcycl)
			end
		end
		
	end
	
	return true
end

addHook("AbilitySpecial", LilacAbilityHit)


//heading towards slope?
local function SlopeDetect(player)

	if not (player.mo.momz) then
		return false
	end

	local slope
	//heading up
	if (player.mo.momz > 0) then
		slope = player.mo.subsector.sector.c_slope

		if (player.mo.ceilingrover) then
			slope = player.mo.ceilingrover.b_slope
		end
	
	else	
		slope = player.mo.subsector.sector.f_slope

		if (player.mo.floorrover)
			slope = player.mo.floorrover.t_slope
		end
	end

	return slope
end

//BREAK THOSE FLOORS
local function BustableDetect(player)
	local rover
	
	if (player.mo.momz > 0) then
		rover = player.mo.ceilingrover
	else
		rover = player.mo.floorrover
	end
	
	if not (rover)
	or not (rover.flags & FF_EXISTS)
	or not (rover.flags & FF_BUSTUP) then
		return
	end
	
	if (P_MobjFlip(player.mo)*(player.mo.z+player.mo.height) > (rover.bottomheight+1))
	and (P_MobjFlip(player.mo)*(player.mo.z+player.mo.momz) < (rover.topheight+1))
		EV_CrumbleChain(rover)
		return true
	end
end

local function LilacDragonDash(player)

	//our own floor bounce detection rigged together from the source
	//if (player.mo.flags & MF_BOUNCE)
	if (player.lilac.dash)
	and (player.mo.momz) then
		local newz = player.mo.z + player.mo.momz

		//hit the floor/ceiling
		//unfortunately currently no P_CeilingzAtPos
		//means you'll bounce off spikes on ceilings, shrug
		if (newz <= P_FloorzAtPos(player.mo.x, player.mo.y, player.mo.z, player.mo.height))
		or (newz+player.mo.height >= player.mo.ceilingz) then
			
			//don't bounce when hitting a slope
			if not (SlopeDetect(player))
			and not (BustableDetect(player)) then
				player.mo.momz = -player.mo.momz
				S_StartSound(player.mo, player.mo.info.activesound)
			end
		end
	end


	//fuck it this works
	//gets set to this state if you hold spin whilst boosting
	if (player.mo.state == 13) then
		player.mo.state = S_LILAC_BOOST
	end

	//Remove Boost when expired or forced to change states!
	if (player.lilac.meter <= 0)
	or not (player.mo.state == S_LILAC_STARTSPIN)
	and not (player.mo.state == S_LILAC_SPIN)
	and not (player.mo.state == S_LILAC_BOOST) then
		
		if (P_IsObjectOnGround(player.mo)) then
			player.pflags = $1 & ~PF_JUMPED
		end
		
		if (player.lilac.meter > 100) then
			player.lilac.meter = 100
		end
		
		player.pflags = $1 & ~PF_DRILLING

		player.jumpfactor = skins[player.mo.skin].jumpfactor
		player.mo.flags = $1 & ~(MF_NOGRAVITY|MF_BOUNCE|MF_GRENADEBOUNCE|MF_MISSILE)
		player.lilac.dash = false
		return
	end

	local dashSpeed = 65
	
	if (player.powers[pw_super]) then
		dashSpeed = 90
	end

	local drainCount = 4
	
	LilacMeterDrain(player, drainCount)
	
	//sparkles
	if not (leveltime % (TICRATE/7))
		local sparkle = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_IVSP)
		sparkle.destscale = player.mo.scale
		P_SetScale(sparkle, player.mo.scale)
	end

	
	if (player.lilac.meter > 100)
	or (player.mo.state == S_LILAC_STARTSPIN) then
		player.mo.momx,player.mo.momy,player.mo.momz = 0,0,0
		player.pflags = $1|PF_STASIS|PF_JUMPED
		
		//Remove shootable to prevent damage
		//remove special so the player doesn't bounce off stuff
		//MF_MISSILE causes the player to bounce off objects
		player.mo.flags = $1|MF_NOGRAVITY|MF_BOUNCE|MF_GRENADEBOUNCE// & ~(MF_SPECIAL)
		return
	end
	

	//disable controls and set drilling to break bustables from above/below
	player.pflags = $1|PF_FULLSTASIS|PF_DRILLING
	//sends you slightly further on land
	player.mo.friction = FRACUNIT
	
	if (player.powers[pw_super]) then
		P_SpawnGhostMobj(player.mo)
		
		local secondGhost = P_SpawnGhostMobj(player.mo)
		P_TeleportMove(secondGhost, player.mo.x-(player.mo.momx/2), player.mo.y-(player.mo.momy/2), player.mo.z-(player.mo.momz/2))
	end
	
	//yes we're being that janky, it works
	if (player.lilac.meter <= 100)
	and (player.mo.state == S_LILAC_SPIN) then
		local dashz = 0
		//Remove jump flag for others to prevent a ground jump bug
		player.jumpfactor = skins[player.mo.skin].jumpfactor
		player.mo.state = S_LILAC_BOOST
		S_StartSound(player.mo, sfx_ldash)
		P_InstaThrust(player.mo, player.mo.angle, dashSpeed*player.mo.scale)
		
		local jumpButton = BT_JUMP
		local spinButton = BT_USE
		
		//invert inputs when the gravity is flipped
		if (player.mo.eflags & MFE_VERTICALFLIP) then
			jumpButton = BT_USE
			spinButton = BT_JUMP
		end
		
		if (player.cmd.buttons & jumpButton) then
			dashz = $1+20
		end
		
		if (player.cmd.buttons & spinButton) then
			dashz = $1-20
		end
		player.mo.momz = dashz*FRACUNIT
	end
	
	//Keep facing our direction and keep the speed up!
	if (player.lilac.meter < 100) then
		player.mo.angle = (R_PointToAngle2(player.mo.x, player.mo.y, player.mo.x+player.mo.momx, player.mo.y+player.mo.momy))
		if (player.speed < dashSpeed*player.mo.scale) then
			P_InstaThrust(player.mo, player.mo.angle, dashSpeed*player.mo.scale)
		end
	end
	
end


//Landing safeties for melee in the air
//prevents get overriden by landing
local function LilacAirMeleeSafety(player)

	if (player.lilac.airmelee) then
		if not (player.mo.state == S_LILAC_ATTACK_MOVE) then
			if not (player.lilac.airmeleetics)
			or (player.lilac.dash) then
				LilacAirMeleeReset(player)
				return
			end

			player.mo.state = S_LILAC_ATTACK_MOVE
			player.lilac.airmelee = false
			return
		end

		player.lilac.airmeleetics = player.mo.tics-1
		player.lilac.airmeleeframe = R_Frame2Char(player.mo.frame)
	end
end

local function LilacMelee(player)

	if not (player.mo)
	or not (player.mo.skin == "lilac")
	or not (LilacAbilityAble(player))
	or (P_SuperReady(player)) then
		return
	end

	if not (player.weapondelay) then
	
		//add noskid to prevent melee interruptions
		player.charflags = $1|SF_NOSKID
		if (P_IsObjectOnGround(player.mo))
		and (player.speed < FRACUNIT)
			player.mo.state = S_LILAC_ATTACK
		else
			player.mo.state = S_LILAC_ATTACK_MOVE
			player.pflags = $1|PF_NOJUMPDAMAGE & ~PF_SPINNING
			player.lilac.airmelee = true
			LilacAirMeleeSafety(player)
		end
	
		S_StopSoundByID(player.mo, sfx_lcycl)
		S_StopSoundByID(player.mo, sfx_fpcycl)
		
		if not (P_RandomRange(0, 1)) then
			S_StartSound(player.mo, sfx_latk1+(P_RandomRange(0, 2)))
		end
		
		S_StartSound(player.mo, sfx_liatk)
		player.weapondelay = TICRATE/2 + TICRATE/3
	end
	return true
end

addHook("SpinSpecial", LilacMelee)
addHook("JumpSpinSpecial", LilacMelee)


//animation garbage
//abandon all hope ye who enter here
local function LilacAnims(player)

		local speed = FixedDiv(player.speed, FixedMul(player.mo.scale, player.mo.movefactor))

		if (player.mo.state >= S_PLAY_SUPER_TRANS1)
		and (player.mo.state <= S_PLAY_SUPER_TRANS6)
		or (player.mo.state == S_LILAC_VICTORY) then
			return
		end
		
		if (player.mo.state == S_LILAC_DIEFALL)
		and (P_IsObjectOnGround(player.mo)) then
			player.mo.state = S_LILAC_DYING
		end
		
		if (player.mo.state == S_LILAC_DEAD) then
			player.mo.frame = E
			return
		end
		
		if (player.mo.state == S_LILAC_VICTORYEND) then
			player.mo.frame = T
			return
		end
		
		//victory anim for singleplayer
		if (player.exiting)
		and not (player.mo.state == S_LILAC_VICTORY)
		and not (player.mo.state == S_LILAC_VICTORYEND)
		and not (multiplayer) then
			player.mo.state = S_LILAC_VICTORY
			if (player.mo.lilachair.valid) then
				player.mo.lilachair.state = S_LILAC_VICTORY
			end
			return
		end
		
		if (P_IsObjectOnGround(player.mo)) then
			if (player.mo.state == S_LILAC_JUMP)
			or (player.mo.state == S_LILAC_FALL)
			or (player.mo.state == S_LILAC_JUMPTOFALL)
			or (player.mo.state == S_LILAC_BOOST)
			and not (player.lilac.dash) then
				player.mo.cusval = 0
				player.mo.state = S_PLAY_STND
			end
		end
		
		//boost ended in the air
		if (player.mo.state == S_LILAC_BOOST)
		and not (player.lilac.dash) then
			player.mo.state = S_LILAC_JUMPTOFALL
		end
		
		//fixes state getting switched to running when
		//the player dashes straight onto equal level ground over a gap
		if (player.lilac.dash)
		and not (player.mo.state == S_LILAC_BOOST) then
			if (player.mo.state == S_PLAY_RUN) then
				player.mo.state = S_LILAC_BOOST
			end
		end
		
		if (player.mo.state == S_PLAY_STND)
		or (player.mo.state == S_PLAY_EDGE) then
			player.mo.state = S_LILAC_STAND
			player.lilac.idletimer = P_RandomRange(TICRATE*6, TICRATE*11)
		end
		

		if (player.speed)
		and not (player.powers[pw_carry] == CR_MINECART)then
			if (LilacIsIdle(player)) then
				player.mo.state = S_PLAY_WALK
			end
		end
		
		//remove twirl when cyclone is done
		if (player.mo.state == S_LILAC_CYCLONE)
		and not (player.flyangle) then
			player.mo.state = S_LILAC_FALL
			player.mo.lilachair.state = S_LILAC_FALL
			player.pflags = $1|PF_NOJUMPDAMAGE & ~PF_SPINNING
		end

		if (player.mo.state == S_PLAY_RUN)
		and (speed > skins[player.mo.skin].normalspeed+8*FRACUNIT)
			if not (player.powers[pw_sneakers]) then
				player.lilac.runanim = true
				player.normalspeed = skins[player.mo.skin].normalspeed+12*FRACUNIT
			end
			player.mo.state = S_PLAY_DASH
		end
		
		//add some leniency so you look cooler
		if (player.mo.state == S_PLAY_DASH)
		and (speed < skins[player.mo.skin].normalspeed) then
			player.mo.state = S_PLAY_RUN
		end
		
		//quick shitty method for controlling animation states for now
		
		if (player.mo.state == S_PLAY_FALL) then
			player.mo.state = S_LILAC_JUMPTOFALL
		end
		
		if (player.mo.state == S_PLAY_JUMP) then
			player.mo.state = S_LILAC_JUMP
			player.mo.frame = A
		end
		
		if (player.mo.state == S_LILAC_JUMP)
		and (player.mo.momz <= 0) then
			player.mo.state = S_LILAC_JUMPTOFALL
		end
		
		if (player.mo.lilachair)
		and (player.mo.lilachair.valid) then
			if not (player.mo.lilachair.state == player.mo.state)
			and not (player.mo.state == S_LILAC_BLINK) then
				player.mo.lilachair.state = player.mo.state
			end
		end
end


//look for a dance floor so we can get dancin'!
//map 23
//teleport -x -12394 -y 7000
local function DanceFloorCheck(player)

	local discoFloors = {
	"DISCO1",
	"DISCO2",
	"DISCO3",
	"DISCO4"
	}
	local floorPic = player.mo.subsector.sector.floorpic

	if (player.mo.eflags & MFE_VERTICALFLIP) then
		floorPic = player.mo.subsector.sector.ceilingpic
		if (player.mo.ceilingrover) then
			floorPic = player.mo.ceilingrover.bottompic
		end
	else	
		if (player.mo.floorrover)
			floorPic = player.mo.floorrover.toppic
		end
	end

	for _,i in ipairs(discoFloors) do
		if (string.find(floorPic,i)) then
			return true
		end
	end
end


//blinking
//also used for idle animations
local function LilacBlink(player)
	if not (player.mo.state == S_LILAC_IDLE) then return end
	
	player.lilac.idletimer = $1-1

	//blinking
	if not (player.mo.cusval % 3)
	and ((player.mo.frame & ~FF_ANIMATE) == A)
		local blinkState = S_LILAC_BLINK
		local idleStates = {
		S_LILAC_IDLE1,
		S_LILAC_IDLE2
		}

		if (player.mo.cusval == 9) then
			player.mo.cusval = 0
		else
			if (player.lilac.idletimer <= 0) then
				player.mo.state = idleStates[P_RandomRange(1, 2)]
				player.lilac.idletimer = P_RandomRange(TICRATE*6, TICRATE*11)
				player.mo.cusval = 0
				return
			end
		end

		if (player.mo.cusval == 6) then
			player.mo.cusval = $1+2
		end
		
		if (DanceFloorCheck(player)) then
			player.mo.state = S_LILAC_DANCE
		else
			player.mo.state = blinkState
		end
	end
end


//Thinkers

local function LilacPresent()
	for player in players.iterate do
		if not (player.mo)
		or not (player.mo.skin == "lilac") then
			continue
		end
		
		//we need invulnerability but no flashing, so go away please thanks
		if (player.powers[pw_flashing]) then
			player.mo.flags2 = $1 & ~MF2_DONTDRAW
		end
		
		//fuck ur music lol
		if (player.powers[pw_extralife] == extralifetics + 1) then
			P_PlayJingleMusic(player, "FPLIFE", 0, false, JT_1UP)
			local chibi = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_LILAC_1UP)
			chibi.scale = player.mo.scale
			chibi.color = player.mo.color
			chibi.target = player.mo
			chibi.angle = 0
			chibi.fuse = 2*TICRATE
		end
		
		//Remove noskid after melee ends
		if (player.mo.state == S_LILAC_STAND)
		or (player.mo.state == S_LILAC_JUMPTOFALL) then
			player.charflags = $1 & ~SF_NOSKID
		end
		
		//air melee hacks
		if (player.lilac.airmeleeframe)
		and not (player.lilac.airmelee) then
			player.mo.frame = R_Char2Frame(player.lilac.airmeleeframe)|FF_ANIMATE
			player.mo.tics = player.lilac.airmeleetics
			player.lilac.airmeleeframe = nil
		end
		
		LilacHealCheck(player)
		LilacAntislide(player)
		LilacAbilities(player)
		LilacAnims(player)
		

		if (player.lilac.dash) then
			LilacDragonDash(player)
		end

		LilacAntiSuper(player)

	end
end

addHook("ThinkFrame", LilacPresent)


//prethinkframe, used for things that should be updated before rendering
local function LilacPre()
	for player in players.iterate do
	
		if (player.mo)
		and (player.mo.skin == "lilachair") then
			R_SetPlayerSkin(player, "lilac")
		end
	
		if not (player.mo)
		or not (player.mo.skin == "lilac") then
		
			if (player.lilac)
			and (player.lilac.meter >= 0) then
				if (player == consoleplayer) then
					hud.enable("lives")
					hud.enable("time")
					hud.enable("rings")
					hud.enable("score")
				end
				player.lilac.meter = -1
				player.mo.state = S_PLAY_STND
			end

			if (player.powers[pw_underwater] > underwatertics) then
				player.powers[pw_underwater] = $1 - underwatertics
			end
			continue
		end

		if not (player.lilac)
		or not (leveltime) then
			LilacSetup(player)
		end
		
		if (player.lilac.meter == -1) then
			player.lilac.meter = 0
			player.mo.state = S_LILAC_STAND
		end
		
		if (player == consoleplayer)
			//appears for a frame in hud hook
			hud.disable("lives")
			hud.disable("time")
			hud.disable("rings")
			hud.disable("score")
		end
		
		//lower the hud!
		if (player.lilac.hudy < 0) then
			player.lilac.hudy = $1+1
		end
		
		if (player.mo.eflags & MFE_UNDERWATER)
		and not (player.exiting)
		and (player.powers[pw_underwater]) then
			//STOP, STOP, SHE'S ALREADY DEA-AAA-AADDDD
			if (player.mo.health <= 0) then
				continue
			end
			LilacDrowning(player)
		else
			//get outta here, hud!
			//oh and restore the music too I guess
			if (player.lilac.hudx > -45) then
				player.lilac.airbonus = false
				player.lilac.hudx = $1-3
				S_FadeMusic(100, 0, player)
			end
		end
		
		//restore our normal speed!
		if (player.lilac.runanim)
		and not (player.mo.state == S_PLAY_DASH)
		and not (player.mo.state == S_LILAC_ATTACK_MOVE) then
			player.normalspeed = skins[player.mo.skin].normalspeed
		end
		
		
		//Only take inputs when alive
		if (player.mo.health > 0)
		and (LilacAbilityAble(player)) then
		
			//activate abilities in the air even if you don't jump

			if (player.cmd.buttons & BT_JUMP)
			and not (P_IsObjectOnGround(player.mo))
			and not (player.pflags & PF_JUMPDOWN) then
				player.pflags = $1|PF_JUMPED|PF_NOJUMPDAMAGE
				LilacAbilityHit(player)
			end
			
			if (player.cmd.buttons & BT_CUSTOM1)
				if (player.lilac.meter == 100) then
					//Prevent jumping
					player.jumpfactor = 0
					S_StartSound(player.mo, sfx_ldchg)
					player.mo.state = S_LILAC_STARTSPIN
					player.lilac.meter = 100+(4*25)
					player.lilac.dash = true
				end
			end
			
		end

		
		LilacAirMeleeSafety(player)
		LilacAntislide(player)
		LilacBlink(player)
	end	
end

addHook("PreThinkFrame", LilacPre)

local function LilacDeath(mo, inflictor, source, damagetype)
	if not (mo.skin == "lilac") then return end

	P_PlayDeathSound(mo)
	
	//remove our hair so it doesn't linger
	if (mo.lilachair)
	and (mo.lilachair.valid) then
		P_RemoveMobj(mo.lilachair)
		mo.lilachair = nil
	end

	if not (P_IsObjectOnGround(mo)) then
		mo.state = S_LILAC_DIEFALL
		mo.frame = E
	else
		mo.state = S_LILAC_DYING
	end

	//change our object type so we don't bounce like players
	mo.type = MT_LILAC_HAIR
	if (mo.player) then
		LilacAirMeleeReset(mo.player)
		mo.player.lives = $1-1
	end
	
	//fall down pits
	if (damagetype == DMG_DEATHPIT)
		mo.state = S_INVISIBLE
		mo.momx,mo.momy,mo.momz = 0,0,0
		mo.flags = MF_NOCLIP
		return true
	end

	return true
end
addHook("MobjDeath", LilacDeath, MT_PLAYER)

local function LilacDamaged(mo, inflictor, source, damage, damagetype)
	if not (mo.skin == "lilac")
	or not (mo.lilachair) then return end
	
	if (mo.player) 
	and (mo.player.powers[pw_shield]) 
		damage = 0
	end
	
	if (mo.player)
	and (mo.player.lilac)
	and (mo.player.lilac.dash) then
		return true
	end
	
	//no damage whilst bein' damaged
	if (mo.state == S_LILAC_PAIN) then return true end
	
	//last chance!
	if (mo.health > 1)
	and (mo.health-(damage*2) <= 0) then
		mo.health = 1
	else
		//double damage so lilac might actually die
		mo.health = $1-(damage*2)
	end
	
	//let them die normally, otherwise they just poof
	if (mo.health <= 0) then
		mo.health = 0
		LilacDeath(mo, inflictor, source, damagetype)
		return true
	end

	if (mo.lilachair.valid) then
		mo.lilachair.state = S_LILAC_PAIN
	end
	
	if (mo.player) then
		if (mo.player.powers[pw_flashing])
		or (mo.player.powers[pw_shield]) then
			return
		end
		LilacAirMeleeReset(mo.player)
		P_DoPlayerPain(mo.player, source, inflictor)
		//nobody modifies flashing tics but oh well
		mo.player.powers[pw_flashing] = (flashingtics/5)*3
	end

	mo.state = S_LILAC_PAIN
	P_PlayRinglossSound(mo)	
	return true
end
addHook("MobjDamage", LilacDamaged, MT_PLAYER)




//This function SUCKS
local function LilacMeleeCheck(player, mo)
	if not (player.mo.skin == "lilac") then return end
	
	//metal sonic exception
	if (mo.type == MT_METALSONIC_BATTLE)
	and not (mo.flags & MF_SHOOTABLE)
	and not (P_IsObjectOnGround(player.mo)) then
		return true
	end
	
	if not (player.mo.state == S_LILAC_ATTACK)
	and not (player.mo.state == S_LILAC_ATTACK_MOVE)
	and not (player.mo.state == S_LILAC_CYCLONE)
	and not (player.lilac.dash) then
		return
	end

	//cez boss
	//bounce off so you don't get crushed!
	if (mo.type == MT_EGGMOBILE4)
	and not (player.lilac.dash) then
		local fallbackSpeed = FixedMul(4*FRACUNIT, mo.scale)
		local ang = R_PointToAngle2(mo.x-mo.momx, mo.y - mo.momy, player.mo.x - player.mo.momx, player.mo.y - player.mo.momy)
		P_InstaThrust(player.mo, ang, player.speed+(fallbackSpeed*7))
		player.mo.momz = (8*FRACUNIT)*P_MobjFlip(player.mo)
	end

	//if you're reading this
	//know i despise monitors
	//they have caused me much suffering
	if (mo.flags & MF_MONITOR) then
		//why the fuck do monitors need their own height checks
		if (P_MobjFlip(player.mo)*(player.mo.z - (mo.z)) > -(2*player.mo.scale))
		and (P_MobjFlip(player.mo)*(player.mo.z - (mo.z)) < mo.height+(2*player.mo.scale))
			P_KillMobj(mo, player.mo, player.mo)
		end
	else
		//Damage the enemy this way instead so we don't bounce
		P_DamageMobj(mo, player.mo, player.mo, 1)
	end
		
	//Single frame invincibility
	//So you don't get hurt whilst the enemy is still "alive"
	if not (player.powers[pw_flashing]) then
		player.powers[pw_flashing] = 1
	end
	
	return false
end

addHook("PlayerCanDamage", LilacMeleeCheck)

local function LilacMeleeCollide(melee, mo)
	if not (melee.target)
	or not (melee.target.player)
	or (mo.player)
	or not (mo.flags & MF_SHOOTABLE) then
		return false
	end
	
	if (P_MobjFlip(melee)*(melee.z - (mo.z)) > -(2*melee.scale))
	and (P_MobjFlip(melee)*(melee.z - (mo.z)) < mo.height+(2*melee.scale))
		LilacMeleeCheck(melee.target.player, mo)
	end
	return false
end
addHook("MobjMoveCollide", LilacMeleeCollide, MT_LILAC_MELEE)

//Makes it so the melee object isn't actually solid but lets us use it for collision checks
local function LilacUnSolid()
	return false
end
addHook("MobjCollide", LilacUnSolid, MT_LILAC_MELEE)

local function LilacBoostSpikes(spike, mo)
	if (mo.state == S_LILAC_BOOST) then
		//only really works when hitting spikes at the same height
		//probably MF_BOUNCE affecting it beforehand
		if (P_MobjFlip(mo)*(mo.z - (spike.z)) > -(2*mo.scale))
		and (P_MobjFlip(mo)*(mo.z - (spike.z)) < spike.height+(2*mo.scale))
		or (P_MobjFlip(mo)*(mo.z+mo.momz) > (spike.z))
		and (P_MobjFlip(mo)*(mo.z+mo.momz) < (spike.z+spike.height))
			P_KillMobj(spike, mo, mo)
			return false
		end
	end
end

addHook("MobjCollide", LilacBoostSpikes, MT_SPIKE)
addHook("MobjCollide", LilacBoostSpikes, MT_WALLSPIKE)

//   ____ _                    _       _               _      __       _            
//  / ___(_)_ __ _ __   ___   (_)___  | |__   ___  ___| |_   / _| __ _(_)_ __ _   _ 
// | |   | | '__| '_ \ / _ \  | / __| | '_ \ / _ \/ __| __| | |_ / _` | | '__| | | |
// | |___| | |  | | | | (_) | | \__ \ | |_) |  __/\__ \ |_  |  _| (_| | | |  | |_| |
//  \____|_|_|  |_| |_|\___/  |_|___/ |_.__/ \___||___/\__| |_|  \__,_|_|_|   \__, |
//                                                                            |___/ 
