//freedom planet styled hud

local function LilacHud(v, player)

	if not (player.mo)
	or not (player.mo.skin == "lilac") then
		return
	end
	
	if not (player.lilac) then return end
	
	local HUDHEIGHT = 10+player.lilac.hudy
	local FPNums = {}
	local FPAir = {}
	
	for i = 1, 10, 1 do
		local patchnum = i-1
		FPNums[i] = v.cachePatch("FPNUM\$patchnum\")
	end
	
	for i = 1, 11, 1 do
		local patchnum = 12-i
		FPAir[i] = v.cachePatch("FPAIR\$patchnum\")
	end
	
	///AIRRRRRRRRRRR
	local airHeight = 80
	local airSide = 20+player.lilac.hudx
	local airPatch = FPAir[11]
	local dTime = player.powers[pw_underwater] - (underwatertics+1)

	//convert to percent
	dTime = ((100*dTime)/(((underwatertics/5)*2)+underwatertics+1))
	//get our patch num from that percent
	dTime = (1+(11*dTime)/100)
	
	if (player.mo.eflags & MFE_UNDERWATER)
	and (player.powers[pw_underwater])
	and not (player.exiting) then
		
		if (dTime < 11) then
			airPatch = FPAir[dTime]
		end
		
		//flashing
		if (dTime <= 1)
			if (leveltime/5 & 1) then
				airPatch = v.cachePatch("FPAIRR")
			else
				airPatch = FPAir[1]
			end
		end
	end
	v.draw(airSide, airHeight, airPatch, V_SNAPTOLEFT|V_PERPLAYER)
	//AIR END


	local gem = v.cachePatch("FPGEM")
	local timer = v.cachePatch("FPTIME")
	

	//LIVES
	local lives = "0\$player.lives\"
	local lifeIcon = v.cachePatch("LILCLIFE")
	local lifeColor = v.getColormap(player.mo.skin, player.mo.color)
	
	if (player.lives > 9) then
		lives = tostring(player.lives)
	end

	for x=1,string.len(lives)
		local numString = string.sub(lives, x, x)
		local patch = FPNums[tonumber(numString)+1]
		v.draw((150 + (x-1)*10), HUDHEIGHT, patch, V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER)
	end
	
	v.draw(134, HUDHEIGHT, lifeIcon, V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER, lifeColor)
	//LIVES END


	//ENERGY BAR
	local inside = v.cachePatch("BARINS")
	local outer = v.cachePatch("DRGNBAR")
	
	if (player.mo.health <= 1)
	and (leveltime/5 & 1) then //powerful knowledge from the source code
		outer = v.cachePatch("DRGNBARR")
	end

	v.draw(16, HUDHEIGHT, inside, V_SNAPTOLEFT|V_SNAPTOTOP|V_SNAPTOTOP|V_PERPLAYER)
	v.draw(16, HUDHEIGHT, outer, V_SNAPTOLEFT|V_SNAPTOTOP|V_SNAPTOTOP|V_PERPLAYER)
	
	local BARC1 = 255	//main
	local BARC2 = 1		//white
	local BARC3 = 135	//lower
	local meter = player.lilac.meter
	
	//set a case for over 100, so we can use it as a timer for dashing
	if (meter > 100) then
		meter = 100
	end
	
	if (meter) then
		v.drawFill(24, HUDHEIGHT+2, meter, 7, BARC1|V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER)
		v.drawFill(24, HUDHEIGHT+3, meter, 2, BARC2|V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER)
		v.drawFill(24, HUDHEIGHT+5, meter, 3, BARC3|V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER)
	end
	//ENERGY BAR END
	
	
	//gems, ft rings
	v.draw(173, HUDHEIGHT, gem, V_SNAPTOLEFT|V_SNAPTOTOP|V_SNAPTOTOP|V_PERPLAYER)
	
	local ringString = player.rings
	if (player.rings > 999) then
		ringString = "999"
	end
	
	if (player.rings < 100) then
		if (player.rings > 9) then
			ringString = "0\$player.rings\"
		else
			ringString = "00\$player.rings\"
		end
	end

	for x=1,string.len(ringString)
		local numString = string.sub(ringString, x, x)
		local patch = FPNums[tonumber(numString)+1]
		v.draw(182 + (x-1)*10, HUDHEIGHT, patch, V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER)
	end
	//GEMS END
	
	
	//TIMER
	//minus the width (66) and minus 3 (10*3) times a number's size +
	local TIMERPOS = 224
	v.draw(TIMERPOS, HUDHEIGHT, timer, V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER)
	
	local times = {
	G_TicsToMinutes(player.realtime),
	G_TicsToSeconds(player.realtime),
	G_TicsToCentiseconds(player.realtime)
	}
	
	local timerSpace = 0
	for x=1, table.maxn(times), 1 do
		if (times[x] > 99) then
			times[x] = "99"
		else
			if (times[x] < 10) then
				times[x] = "0\$times[x]\"
			else
				times[x] = tostring(times[x])
			end
		end

		for i=1, string.len(times[x]), 1 do
			local numPos = (i-1)
			local offsetPos = (x-1)
			
			local numPatch = FPNums[1+string.sub(times[x], i, i)]
			v.draw(TIMERPOS+(10*numPos)+15+(16*offsetPos)+(10*offsetPos), HUDHEIGHT, numPatch, V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER)
		end
	end
	
	
	//Health
	local flower = v.cachePatch("FLOWER")
	local smallFlower = v.cachePatch("FLOWERS")
	local health = (player.mo.health-1)
	
	for x = 1,health do
		if (x == health)
		and not (x % 2 == 0) then
			v.draw((16*((x/2)+1)), HUDHEIGHT+10, smallFlower, V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER)
		else
			//don't render the first
			if (x==1) then continue end
			v.draw((16*(x/2)), HUDHEIGHT+10, flower, V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER)
		end
	end
end
hud.add(LilacHud)
