freeslot(
"S_LILAC_WALK",
"S_LILAC_RUN",
"S_LILAC_CLEAR",
"S_LILAC_STAND",
"S_LILAC_IDLE",
"S_LILAC_IDLE2",
"S_LILAC_IDLE3",
"S_LILAC_DANCE",
"S_LILAC_FALL",
"S_LILAC_JUMPTOFALL",
"S_LILAC_JUMP",
"S_LILAC_ATTACK",
"S_LILAC_ATTACK_MOVE",
"S_LILAC_STARTSPIN",
"S_LILAC_SPIN",
"S_LILAC_PAIN",
"S_LILAC_DYING",
"S_LILAC_DEAD",
"S_LILAC_SWIM",
"S_LILAC_1UP",
"S_LILAC_CYCLONE",
"S_LILAC_BOOST",
"S_LILAC_SLIDE",
"S_LILAC_VICTORY",
"S_LILAC_VICTORYEND",
"S_LILAC_DIEFALL",
"S_LILAC_BLINK",
"S_LILAC_DANCE",
"S_LILAC_IDLE1",
"S_LILAC_IDLE2",
"MT_LILAC_HAIR",
"MT_LILAC_1UP",
"MT_LILAC_MELEE",
"spr_ltim",
"spr_lilf",
"spr2_idle",
"spr2_stmd",
"spr2_cycl",
"spr2_boos",
"spr2_vict",
"spr2_ratk",
"spr2_atk1",
"spr2_atk2",
"spr2_vict",
"spr2_blnk",
"spr2_danc",
"spr2_idl1",
"spr2_idl2",
"sfx_fptick",
"sfx_fptock",
"sfx_fpcycl",
"sfx_fpheal",
"sfx_lcycl",
"sfx_liatk",
"sfx_latk1",
"sfx_latk2",
"sfx_latk3",
"sfx_ldchg",
"sfx_ldbnc",
"sfx_ldash",
"SKINCOLOR_SASH"
)

//everything is defined here so let's add the skincolor here

skincolors[SKINCOLOR_SASH] = {
	name = "Sash",
	ramp = {160,160,160,161,161,161,162,162,162,163,163,163,172,197,197,197},
	invcolor = SKINCOLOR_EMERALD,
	invshade = 1,
	chatcolor = V_PURPLEMAP,
	accessible = true
}

//i seriously doubt this will conflict so let's do it
mobjinfo[MT_PLAYER].activesound = sfx_ldbnc


mobjinfo[MT_LILAC_HAIR] = {
	spawnstate = S_LILAC_IDLE,
	deathstate = S_LILAC_DYING,
	dispoffset = -1
}

//16, 48
mobjinfo[MT_LILAC_MELEE] = {
	spawnstate = S_INVISIBLE,
	radius = 40*FRACUNIT,
	height = 48*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_SOLID
}

//1UP Effect

mobjinfo[MT_LILAC_1UP] = {
	spawnstate = S_LILAC_1UP,
	xdeathstate = S_SPRK1,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT
}

local function FPLifeThinker(mo)
	if not (mo.target)
	or not (mo.target.valid) then
		P_RemoveMobj(mo)
		return
	end
	
	mo.scale = mo.target.scale
	mo.color = mo.target.color
	
	local x,y,z
	if (mo.movecount < mo.target.height+5*mo.scale)
		mo.movecount = $1+FRACUNIT
	end

	x = mo.target.x + FixedMul(cos(mo.angle), mo.target.radius+(5*mo.scale))
	y = mo.target.y + FixedMul(sin(mo.angle), mo.target.radius+(5*mo.scale))
	z = mo.target.z + mo.movecount
	
	P_TeleportMove(mo, x, y, z)
	
	mo.angle = $1+(ANG1*24)
	
end

addHook("MobjThinker", FPLifeThinker, MT_LILAC_1UP)


states[S_LILAC_1UP] = {SPR_LILF, A|FF_ANIMATE, 1, A_GoldMonitorSparkle, 2, 2, S_LILAC_1UP}



states[S_LILAC_VICTORY] = {SPR_PLAY, SPR2_VICT|FF_SPR2ENDSTATE, 3, nil, S_LILAC_VICTORYEND, 0, S_LILAC_VICTORY}
states[S_LILAC_VICTORYEND] = {SPR_PLAY, SPR2_VICT|FF_ANIMATE, -1, nil, 0, 0, S_PLAY_STND}


states[S_LILAC_WALK] = {SPR_PLAY, SPR2_WALK|FF_ANIMATE, -1, nil, 11, 4, S_LILAC_WALK}
states[S_LILAC_RUN] = {SPR_PLAY, SPR2_RUN|FF_ANIMATE, -1, nil, 7, 4, S_LILAC_RUN}


states[S_LILAC_JUMP] = {SPR_PLAY, SPR2_JUMP, -1, nil, 9, 4, S_LILAC_JUMPTOFALL}
states[S_LILAC_JUMPTOFALL] = {SPR_PLAY, SPR2_JUMP|FF_SPR2ENDSTATE, 4, nil, S_LILAC_FALL, 4, S_LILAC_JUMPTOFALL}
states[S_LILAC_FALL] = {SPR_PLAY, SPR2_FALL|FF_ANIMATE, -1, nil, 9, 4, S_LILAC_FALL}

//FAST
states[S_LILAC_CYCLONE] = {SPR_PLAY, SPR2_CYCL|FF_ANIMATE, -1, nil, 28, 2, S_LILAC_STARTSPIN}


states[S_LILAC_ATTACK] = {SPR_PLAY, SPR2_ATK1|FF_ANIMATE, 14, nil, 6, 2, S_LILAC_STAND}
states[S_LILAC_ATTACK_MOVE] = {SPR_PLAY, SPR2_RATK|FF_ANIMATE, 14, nil, 6, 2, S_LILAC_JUMPTOFALL}


states[S_LILAC_STARTSPIN] = {SPR_PLAY, SPR2_SPIN|FF_ANIMATE, 12, nil, 5, 2, S_LILAC_SPIN}
states[S_LILAC_SPIN] = {SPR_PLAY, SPR2_ROLL|FF_ANIMATE, -1, nil, 0, 2, S_LILAC_SPIN}
states[S_LILAC_BOOST] = {SPR_PLAY, SPR2_BOOS|FF_ANIMATE, -1, nil, 3, 2, S_LILAC_BOOST}


states[S_LILAC_BLINK] = {SPR_PLAY, SPR2_BLNK|FF_SPR2ENDSTATE, 4, nil, S_LILAC_IDLE, 4, S_LILAC_BLINK}

states[S_LILAC_IDLE1] = {SPR_PLAY, SPR2_IDL1|FF_SPR2ENDSTATE, 4, nil, S_LILAC_IDLE, 0, S_LILAC_IDLE1}
states[S_LILAC_IDLE2] = {SPR_PLAY, SPR2_IDL2|FF_SPR2ENDSTATE, 4, nil, S_LILAC_IDLE, 0, S_LILAC_IDLE2}

//blink chance increases per loop
function A_LilacBlink(actor, var1, var2)
    actor.cusval = $1+1
end

states[S_LILAC_STAND] = {SPR_PLAY, SPR2_STMD|FF_SPR2ENDSTATE, 4, nil, S_LILAC_IDLE, 4, S_LILAC_STAND}
states[S_LILAC_IDLE] = {SPR_PLAY, SPR2_IDLE|FF_ANIMATE, 48, A_LilacBlink, 11, 4, S_LILAC_IDLE}

states[S_LILAC_DANCE] = {SPR_PLAY, SPR2_DANC|FF_ANIMATE, -1, nil, 13, 3, S_LILAC_STAND}


//pain leads to falling if in the air 
states[S_LILAC_PAIN] = {SPR_PLAY, SPR2_PAIN|FF_SPR2ENDSTATE, 4, nil, S_LILAC_FALL, 4, S_LILAC_PAIN}


states[S_LILAC_SLIDE] = {SPR_PLAY, SPR2_PAIN, 2, nil, 0, 0, S_PLAY_STND}

//dying is the animation, dead is flying flat on the ground
//what a loser!! lol!!!!!
states[S_LILAC_DIEFALL] = {SPR_PLAY, SPR2_PAIN, -1, nil, 0, 0, S_LILAC_DIEFALL}
states[S_LILAC_DYING] = {SPR_PLAY, SPR2_DEAD|FF_SPR2ENDSTATE, 4, nil, S_LILAC_DEAD, 4, S_LILAC_DYING}
states[S_LILAC_DEAD] = {SPR_PLAY, SPR2_DEAD, -1, nil, 0, 0, S_LILAC_DEAD}
